<?php

/**
 * @file
 * Admin page callbacks for the dsc module.
 */

/**
 * Menu callback; Provides a setting form.
 */
function dsc_admin_settings($form, &$form_state) {
  $form = array();
  module_load_include('admin.inc', 'dblog');
  $filters = dblog_filters();
  // We keep a trace of all possible types.
  // Need to do so to cleanup vars at uninstall.
  $existing = array();
  foreach ($filters['type']['options'] as $type_name => $type_label) {
    $existing[] = $type_name;
    $form['dsc_' . $type_name] = array(
      '#type' => 'fieldset',
      '#title' => t('Number of watchdog entries of type @type to keep', array('@type' => $type_name)),
      '#attributes' => array('class' => array('container-inline')),
    );
    foreach ($filters['severity']['options'] as $severity) {
      $form['dsc_' . $type_name]['dsc_num_' . $type_name . '_' . $severity] = array(
        '#type' => 'textfield',
        '#title' => $severity,
        '#size' => 6,
        '#default_value' => variable_get('dsc_num_' . $type_name . '_' . $severity, 100),
      );
    }
  }
  $form['dsc_existing_types'] = array(
    '#type' => 'hidden',
    '#value' => $existing,
  );

  return system_settings_form($form);
}